%global bootstrap 1

%if !0%{?bootstrap}
%global tests 1
%endif

%bcond_without wayland_default

Summary: KDE Window manager
Name:    kwin
Version: 5.27.9
%global majmin_ver %(echo %{version} | cut -d. -f1,2)
Release: 1%{?dist}
License: GPLv2 or GPLv3
URL:     https://userbase.kde.org/KWin
Source0: http://download.kde.org/stable/plasma/%{version}/%{name}-%{version}.tar.xz
Patch0001: fix-nvidia-screencast.patch
BuildRequires:  extra-cmake-modules, kf5-rpm-macros, systemd-rpm-macros
BuildRequires:  qaccessibilityclient-devel
BuildRequires:  qt5-qtbase-devel, qt5-qtbase-static, qt5-qtbase-private-devel
BuildRequires:  qt5-qtsensors-devel, qt5-qtscript-devel, qt5-qttools-devel
BuildRequires:  qt5-qttools-static, qt5-qtx11extras-devel, qt5-qtwayland-devel
BuildRequires:  pkgconfig(libxcvt), mesa-libGL-devel, mesa-libEGL-devel
BuildRequires:  mesa-libgbm-devel
BuildRequires:  libxkbcommon-devel, libxkbcommon-x11-devel, libX11-devel
BuildRequires:  libXi-devel, libxcb-devel, libICE-devel
BuildRequires:  libSM-devel, libXcursor-devel
BuildRequires:  xcb-util-wm-devel, xcb-util-image-devel, xcb-util-devel
BuildRequires:  xcb-util-keysyms-devel, xcb-util-cursor-devel
BuildRequires:  libepoxy-devel, libcap-devel
BuildRequires:  lcms2-devel, glib2-devel, pipewire-devel
BuildRequires:  kf5-kwayland-devel, wayland-devel, wayland-protocols-devel
BuildRequires:  libxkbcommon-devel >= 0.4, pkgconfig(libinput) >= 0.10, pkgconfig(libudev)
BuildRequires:  kf5-kcompletion-devel, kf5-kconfig-devel, kf5-kconfigwidgets-devel
BuildRequires:  kf5-kcoreaddons-devel, kf5-kcrash-devel, kf5-kdbusaddons-devel
BuildRequires:  kf5-kglobalaccel-devel, kf5-ki18n-devel, kf5-kinit-devel >= 5.10.0-3
BuildRequires:  kf5-kio-devel, kf5-knotifications-devel, kf5-kservice-devel
BuildRequires:  kf5-plasma-devel, kf5-kwidgetsaddons-devel, kf5-kwindowsystem-devel
BuildRequires:  kf5-kdoctools-devel, kf5-kcmutils-devel, kf5-knewstuff-devel
BuildRequires:  kf5-kactivities-devel, kf5-kdoctools-devel, kf5-kdeclarative-devel
BuildRequires:  kf5-kiconthemes-devel, kf5-kidletime-devel, kf5-ktextwidgets-devel
BuildRequires:  kf5-kirigami2-devel, kf5-krunner-devel
BuildRequires:  kdecoration-devel >= %{majmin_ver}
BuildRequires:  kscreenlocker-devel >= %{majmin_ver}
BuildRequires:  plasma-breeze-devel >= %{majmin_ver}
BuildRequires:  plasma-wayland-protocols-devel
%if ! 0%{?bootstrap}
BuildRequires:  qt5-qtmultimedia-devel, qt5-qtvirtualkeyboard
%endif

%if 0%{?tests}
BuildRequires: dbus-x11, openbox, xorg-x11-server-Xvfb
%endif

Requires:       %{name}-libs = %{version}-%{release}
Requires:       %{name}-common = %{version}-%{release}
Requires:       kdecoration >= %{majmin_ver}
Requires:       kscreenlocker >= %{majmin_ver}
Requires:       qt5-qtmultimedia
Recommends:     qt5-qtvirtualkeyboard
%{?kf5_kinit_requires}

Provides: firstboot(windowmanager) = kwin

%if ! %{with wayland_default}
Recommends: %{name}-wayland = %{version}-%{release}
Requires:   %{name}-x11 = %{version}-%{release}
%else
Requires:   %{name}-wayland = %{version}-%{release}
Recommends: %{name}-x11 = %{version}-%{release}
%endif

%description
%{summary}.

%package        wayland
Summary:        KDE Window Manager with Wayland support
%if ! 0%{?bootstrap}
BuildRequires:  xorg-x11-server-Xwayland
%endif
Requires:       %{name}-libs = %{version}-%{release}
Requires:       %{name}-common = %{version}-%{release}
Requires:       kwayland-integration >= %{majmin_ver}
Requires:       xorg-x11-server-Xwayland
Provides:       firstboot(windowmanager) = kwin_wayland
%{?kf5_kinit_requires}
Provides:       %{name}-wayland-nvidia = %{version}-%{release}

%description    wayland
%{summary}.

%package        x11
Summary:        KDE Window Manager with X11 support
%if ! 0%{?bootstrap}
BuildRequires:  xorg-x11-server-Xorg
%endif
Requires:       %{name}-libs = %{version}-%{release}
Requires:       %{name}-common = %{version}-%{release}
Requires:       xorg-x11-server-Xorg
Provides:       deprecated()
Provides:       firstboot(windowmanager) = kwin_x11
%{?kf5_kinit_requires}

%description    x11
%{summary}.

%package        common
Summary:        Common files for KWin X11 and KWin Wayland
Requires:       %{name}-libs = %{version}-%{release}
Requires:       kf5-kwayland >= 5.91.0

%description    common
%{summary}.

%package        libs
Summary:        KWin runtime libraries

%description    libs
%{summary}.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}-libs = %{version}-%{release}
Requires:       %{name}-common = %{version}-%{release}
Requires:       kf5-kconfig-devel
Requires:       kf5-kservice-devel
Requires:       kf5-kwindowsystem-devel

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package        doc
Summary:        User manual for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
%{summary}.

%prep
%autosetup -p1

sed -i \
  -e 's|^find_package(Breeze ${PROJECT_VERSION} CONFIG)|find_package(Breeze 5.9 CONFIG)|' \
  CMakeLists.txt

%build
%cmake_kf5 \
  -DBUILD_TESTING:BOOL=%{?tests:ON}%{!?tests:OFF}

%cmake_build

%install
%cmake_install

%find_lang %{name} --with-html --all-name
grep "%{_kf5_docdir}" %{name}.lang > %{name}-doc.lang
cat %{name}.lang %{name}-doc.lang | sort | uniq -u > kwin5.lang

%if ! %{with wayland_default}
ln -s kwin_x11 %{buildroot}%{_bindir}/kwin
%else
ln -s kwin_wayland %{buildroot}%{_bindir}/kwin
%endif


%check
%if 0%{?tests}
export CTEST_OUTPUT_ON_FAILURE=1
xvfb-run -a \
dbus-launch --exit-with-session \
make test ARGS="--output-on-failure --timeout 10" -C %{_target_platform} ||:
%endif

%files
%{_bindir}/kwin

%files common -f kwin5.lang
%{_kf5_qtplugindir}/plasma/kcms/systemsettings/*.so
%{_kf5_qtplugindir}/plasma/kcms/systemsettings_qwidgets/*.so
%{_kf5_qtplugindir}/kwin/
%{_kf5_qtplugindir}/kpackage/packagestructure/
%{_kf5_qtplugindir}/org.kde.kdecoration2/*.so
%{_qt5_qmldir}/org/kde/kwin
%{_qt5_qmldir}/org/kde/kwin.2/qmldir
%{_qt5_qmldir}/org/kde/kwin.2/DesktopThumbnailItem.qml
%{_kf5_libdir}/kconf_update_bin/kwin5_update_default_rules
%{_libexecdir}/kwin_killer_helper
%{_libexecdir}/kwin_rules_dialog
%{_libexecdir}/kwin-applywindowdecoration
%{_datadir}/kwin
%{_datadir}/kconf_update/kwin.upd
%{_datadir}/kconf_update/kwin-5.16-auto-bordersize.sh
%{_datadir}/kconf_update/kwin-5.18-move-animspeed.py
%{_datadir}/kconf_update/kwin-5.21-desktop-grid-click-behavior.py
%{_datadir}/kconf_update/kwin-5.21-no-swap-encourage.py
%{_datadir}/kconf_update/kwin-5.23-disable-translucency-effect.sh
%{_datadir}/kconf_update/kwin-5.23-remove-cover-switch.py
%{_datadir}/kconf_update/kwin-5.23-remove-cubeslide.py
%{_datadir}/kconf_update/kwin-5.23-remove-flip-switch.py
%{_datadir}/kconf_update/kwin-5.23-remove-xrender-backend.py
%{_datadir}/kconf_update/kwinrules-5.23-virtual-desktop-ids.py
%{_kf5_datadir}/kservicetypes5/*.desktop
%{_kf5_datadir}/kpackage/kcms/kcm_*
%{_kf5_datadir}/knotifications5/kwin.notifyrc
%{_kf5_datadir}/config.kcfg/kwin.kcfg
%{_kf5_datadir}/config.kcfg/kwindecorationsettings.kcfg
%{_kf5_datadir}/config.kcfg/virtualdesktopssettings.kcfg
%{_kf5_datadir}/config.kcfg/nightcolorsettings.kcfg
%{_kf5_datadir}/kconf_update/kwinrules-5.19-placement.pl
%{_kf5_datadir}/kconf_update/kwinrules.upd
%{_kf5_datadir}/kconf_update/kwin-5.25-effect-pluginid-config-group.py
%{_kf5_datadir}/kconf_update/kwin-5.27-replace-cascaded-zerocornered.sh
%{_datadir}/icons/hicolor/*/apps/kwin.*
%{_datadir}/knsrcfiles/*.knsrc
%{_datadir}/krunner/dbusplugins/kwin-runner-windows.desktop
%{_datadir}/applications/*.desktop

%files wayland
%{_bindir}/kwin_wayland_wrapper
%{_kf5_bindir}/kwin_wayland
%{_userunitdir}/plasma-kwin_wayland.service

%files x11
%{_kf5_bindir}/kwin_x11
%{_userunitdir}/plasma-kwin_x11.service

%files libs
%{_libdir}/libkwin.so.*
%{_libdir}/libkwineffects.so.*
%{_libdir}/libkwinglutils.so.*
%{_libdir}/libkcmkwincommon.so.*
%{_kf5_datadir}/qlogging-categories5/org_kde_kwin.categories

%files devel
%{_includedir}/kwin*.h
%{_libdir}/cmake/KWinDBusInterface
%{_libdir}/cmake/KWinEffects
%{_libdir}/libkwineffects.so
%{_libdir}/libkwinglutils.so
%{_datadir}/dbus-1/interfaces/*.xml

%files doc -f %{name}-doc.lang
%license LICENSES/*.txt


%changelog
* Tue Nov 28 2023 Chair <chairou@tencent.com> - 5.27.9-1
- Init
